import React, { Component } from 'react';
import { connect } from 'react-redux';
require('../array');
// import {
//     CardIOView,
//     CardIOUtilities,
//     CardIOModule
// } from 'react-native-awesome-card-io';
import {
    Container,
    Header,
    Content,
    Footer,
    FooterTab,
    Button,
    Icon,
    List,
    ListItem,
    InputGroup,
    Input,
    Body,
    Title,
    Left,
    Right,
    Card,
    Spinner,
    CardItem,

} from 'native-base';
import * as Colors from '../colors';
import * as Common from '../common';

import {
    Text,
    KeyboardAvoidingView,
    StyleSheet,
    View,
    Platform,
    Item, Image,
    TouchableOpacity,
    Picker, Dimensions
} from 'react-native';

import * as utils from '../util';


import * as Titles from '../titles';



import { Actions } from 'react-native-router-flux';
const listpadding = 20;

class InfiniteListSelect extends Component {
    constructor(props) {
        super(props);
        this.state = {
            filter: '',
            show: false
        };
    }
    render() {
        var me = this;
        var { options, inputprops } = me.props;
        var hr_ = options.hr_;
        var flex = options.flex;
        return (
            <KeyboardAvoidingView behavior={'position'}>
                <View style={{ flexDirection: 'column' }}>
                    <InputGroup  {...options.errorGroupState() }>
                        {options.errorIcon()}
                        <Input
                            {...inputprops}
                            ref={r => me.input = r}
                            style={Object.assign({ flex: 1 }, options.lightMode ? { color: Colors.Dark } : null, options.inputStyle())}
                            value={me.state.filter || options.value()}
                            onChangeText={val => {
                                me.setState({
                                    filter: val,
                                    show: true
                                });
                                options.onValueChange(null);
                            }}
                            placeholderTextColor={options.required() ? Colors.Danger : Colors.LighterDark}
                            placeholder={options.placeHolder + (options.required() ? '*' : '')} />

                    </InputGroup>
                    {hr_}
                    {options.errorText()}
                    {me.state.show ? (<List>{
                        options.items().filter(t => {
                            if (!t || !me.state.filter) {
                                return false;
                            }
                            return ((t.name || '-!@#$').toLowerCase()).indexOf((me.state.filter || '').toLowerCase()) !== -1;
                        }).subset(0, me.props.maxShow || 5).map((t, index) => {
                            return (
                                <ListItem key={`'infin' + ${t.id} ${index}`} onPress={() => {
                                    if (options.onValueChange) {
                                        options.onValueChange(t);
                                        me.setState({
                                            filter: null,
                                            show: false
                                        });
                                    }
                                }}>
                                    <Text>{t.name}</Text>
                                </ListItem>
                            )
                        })
                    }</List>) : null}
                </View>
            </KeyboardAvoidingView>
        );
    }
}
export default (InfiniteListSelect); 