'use strict';
import React, { Component } from 'react';
import {
    AppRegistry,
    StyleSheet,
    WebView,
    View, AsyncStorage
} from 'react-native';
import { Actions } from 'react-native-router-flux';
import * as Titles from '../titles';
import * as UIA from '../actions/uiActions';
import * as Common from '../common';

import {
    Container,
    Header,
    Footer,
    FooterTab,
    Body,
    Spinner,
    Button,
    Content,
    List,
    ListItem,
    Text
} from 'native-base';
// Change these to reflect
export default class RedScreenListComponent extends Component {
    constructor(props) {
        super(props);
        this.state = {
            objectValue: null
        };
    }
    componentDidMount() {
        var me = this;
        me.loadList();
    }
    loadList() {
        var me = this;
        me.props.getRedObjectList(me.props.objectType);
    }
    getText(item) {
        return null;
    }
    getListItem(item) {
        var me = this;
        var icon = me.getItemIcon(item);
        return (
            Common.ListButtonItem(icon, me.getText(item), me.getItemAction(item), me.getItemBody(item), me.getItemRight(item), me.getKey(item))
        )
    }
    getFooter() {
        return null;
    }
    getKey(item) {
        return item ? item.id : null;
    }
    getItemAction(item) {
        return () => { };
    }
    getItemRight(item) {
        return null;
    }
    getItemBody() {
        return null;
    }
    getRightHeader() {
        return null;
    }
    render() {
        var me = this;
        var { state } = me.props;
        var ui = UIA.GetC(state, UIA.UI_DEFINIONS, me.props.objectType);
        var items = UIA.GetC(state, UIA.OBJECT_LISTS, me.props.objectType);
        items = (items || this.props.items || []);
        return (
            <Container>
                <Header>
                    {Common.BackButton()}
                    {Common.HeaderTitle(me.props.title)}
                    {me.getRightHeader()}
                </Header>
                <Content>
                    {UIA.GetC(state, UIA.LOADING_OBJECT_LISTS, me.props.objectType) ? <Spinner /> : null}
                    <List>{
                        items.length ? items.map(item => {
                            return me.getListItem(item);
                        }) : (Common.EmptyList())
                    }</List>
                </Content>
                {me.getFooter()}
            </Container>
        )
    }
}

const styles = ({
});
