import { Scene, Router } from 'react-native-router-flux';
import Login from './screens/login';
import * as Titles from './titles';
import * as utils from './util';
import React, { Component } from 'react';
import { connect, Provider } from 'react-redux';
import { createStore, applyMiddleware, compose } from 'redux';
import thunk from 'redux-thunk';
const RouterWithRedux = connect()(Router);
import reducers from './reducers';
import * as Keys from './keys';
// other imports...
import {
    TabBar,
    Modal,
    Schema,
    Actions,
    Reducer,
    ActionConst
} from 'react-native-router-flux'
import {
    Dimensions, AppState
} from 'react-native';
// create store...
const middleware = [thunk, utils.asyncStorage/* ...your middleware (i.e. thunk) */];
const store = compose(
    applyMiddleware(...middleware)
)(createStore)(reducers);
import { Root } from "native-base";

class RedApp extends React.Component {
    componentDidMount() {
        AppState.addEventListener('change', state => {
            console.log('AppState changed to', state)
            if (me.props.appStateChange) {
                me.props.addStateChange({ type: 'change', state });
            }
        })
    }
    render() {
        var me = this;
        var scenes = [];
        if (me.props.userLogin) {
            scenes.push((<Scene key={Keys.Login} component={Login} type={ActionConst.RESET} hideNavBar={true} title="Login" />));
        }
        return (
            <Root>
                <Provider store={store}>
                    <RouterWithRedux onEnter={(e) => {
                        console.log(e)
                    }}>
                        <Scene key="root" hideNavBar={true}>
                            {scenes}
                            {this.props.children}
                        </Scene>
                    </RouterWithRedux>
                </Provider>
            </Root>
        );
    }
}
export default RedApp; 
