import * as Actions from '../actions/uiActions';
import * as Util from '../util';
import * as Titles from '../titles';
import * as UIA from '../actions/uiActions';
function makeState() {
    return {
        [Actions.START_ADDRESS_TEXT]: null,
        [Actions.END_ADDRESS_TEXT]: null,
        [Actions.CUSTOMER_FOOTER_STATE]: null
    }
}
function reset() {
    return makeState();
}
function duplicateState(state) {
    return Object.assign({}, makeState(), state)
}
function updateUi(action, state) {
    var newstate = duplicateState(state);
    newstate[action.name] = action.value;
    return newstate;
}

function updateMergeUi(action, state) {
    var newstate = duplicateState(state);
    newstate[action.name] = Object.assign({}, newstate[action.name], action.value);
    return newstate;
}

function setState(action, state) {
    return action.state || state || makeState();
}

const uiReducer = (state, action) => {
    var actions;
    state = state || makeState();
    if (!action) {
        return state;
    }
    if (action && action.type !== Util.BATCH) {
        actions = [action];
    }
    else {
        actions = action.actions;
    }

    actions.forEach(action => {
        switch (action.type) {
            case UIA.RESET_ALL:
                state = reset();
                break;
            case Actions.UI_UPDATE:
                state = updateUi(action, state);
                break;
            case Actions.UI_UPDATE_MERGE:
                state = updateMergeUi(action, state);
                break;
        }
    });
    return state;
};
export default uiReducer